module Rledger
  # Reconciliation maintains the reconciliation status of a Transaction
  class Reconciliation
    attr_reader :status

    def pending!
      @status = '!'
    end

    def pending?
      @status == '!'
    end 

    def discarded!
      @status = '?'
    end

    def discarded?
      @status == '?'
    end

    def reconciled!
      @status = '*'
    end

    def reconciled?
      @status == '*'
    end

    def unknown!
      @status = ''
    end

    def unknown?
      @status == ''
    end

    def to_s
      @status
    end

    def parse(s)
      case s
      when "*" then reconciled!
      when "!" then pending!
      when "?" then discarded!
      when ""  then unknown!
      else unknown!
      end
    end
  end
end
