module Rledger
  # Balance computes the balance of leaves (at the moment)
  class Balance
    def initialize(transactions)
      @transactions = transactions
    end

    def compute
      @balance = Hash.new

      @transactions.each do |t|
        t.posts.each do |p|
          elements = disaggregate p.voice

          elements.each do |element| 
            @balance[element] ? @balance[element].add!(p.amount) : @balance[element] = p.amount
          end
        end
      end
    end

    def to_s
      @balance.keys.sort.map { |k| puts "#{k} #{@balance[k]}" }
      ""
    end

    private

    # return an array of all the components of a voice
    # Expenses:Dining:Fish -> [Expenses, Expenses:Dining, Expenses:Dining:Fish ]
    def disaggregate voice
      output = []
      aggregator = ""
      voice.split(":").each do |element|
        aggregator = aggregator == "" ? element : aggregator + ":" + element
        output << aggregator
      end
      output
    end

  end
end
